//
//  J_AFNetWorkManager.m
//  LuBa
//
//  Created by 张浩 on 2016/12/16.
//  Copyright © 2016年 LuBa. All rights reserved.
//

#import "J_AFNetWorkManager.h"
#import "AFNetworking.h"
@implementation J_AFNetWorkManager
+(void)GET:(NSString *)requestUrl params:(NSDictionary *)params
   success:(J_ResponseSuccess)success fail:(J_ResponseFail)fail{
    AFHTTPSessionManager *manager = [J_AFNetWorkManager managerWithBaseURL:nil sessionConfiguration:NO];
    // manager.requestSerializer.timeoutInterval = 30;
    
    [manager GET:requestUrl parameters:params progress:nil success:^(NSURLSessionDataTask * _Nonnull task, id  _Nullable responseObject) {
        
        id dic = [NSJSONSerialization  JSONObjectWithData:responseObject options:NSJSONReadingMutableLeaves error:nil];
        
        success(task,dic);
    } failure:^(NSURLSessionDataTask * _Nullable task, NSError * _Nonnull error) {
        fail(task,error);
    }];
}

+(void)GET:(NSString *)requestUrl baseURL:(NSString *)baseUrl params:(NSDictionary *)params
   success:(J_ResponseSuccess)success fail:(J_ResponseFail)fail{
    
    AFHTTPSessionManager *manager = [J_AFNetWorkManager managerWithBaseURL:baseUrl sessionConfiguration:NO];
    [manager GET:requestUrl parameters:params progress:^(NSProgress * _Nonnull downloadProgress) {
        
    } success:^(NSURLSessionDataTask * _Nonnull task, id  _Nullable responseObject) {
        
        id dic = [J_AFNetWorkManager responseConfiguration:responseObject];
        
        success(task,dic);
    } failure:^(NSURLSessionDataTask * _Nullable task, NSError * _Nonnull error) {
        fail(task,error);
    }];
    
}
+(void)GET:(NSString*)requestUrl params:(NSDictionary*)params header:(NSDictionary*)dicHeaders success:(J_ResponseSuccess)success fail:(J_ResponseFail)fail{
    
    AFHTTPSessionManager *manager =  [AFHTTPSessionManager manager];
    AFHTTPRequestSerializer *requestSerializer =  [AFHTTPRequestSerializer serializer];
 
    manager.responseSerializer = [ AFHTTPResponseSerializer serializer];
    manager.responseSerializer.acceptableContentTypes = [NSSet setWithObjects:@"text/plain",@"text/html",@"application/json",@"video/x-flv", nil];
    if (dicHeaders != nil) {
        for (NSString *key in dicHeaders.allKeys) {
            NSString *value = dicHeaders[key];
            [requestSerializer setValue:value forHTTPHeaderField:key];
        }
    }
    manager.requestSerializer = requestSerializer;
 
    
    [manager GET:requestUrl parameters:params progress:^(NSProgress * _Nonnull downloadProgress) {
        
    } success:^(NSURLSessionDataTask * _Nonnull task, id  _Nullable responseObject) {
        NSString *string = [[NSString alloc] initWithData:responseObject encoding:NSUTF8StringEncoding];
        NSString *SOOONER_URL = [dicHeaders objectForKey:@"SOOONER_URL"];
        NSMutableDictionary *resp =[NSMutableDictionary new];
        [resp setObject:SOOONER_URL forKey:@"SOOONER_URL"];
        [resp setObject:string forKey:@"liveUrl"];
        
        success(task,resp);
    } failure:^(NSURLSessionDataTask * _Nullable task, NSError * _Nonnull error) {
        fail(task,error);
    }];
    
    
}
+(void)POST:(NSString *)requestUrl body:(NSDictionary *)params
    success:(J_ResponseSuccess)success fail:(J_ResponseFail)fail{
    
    AFHTTPSessionManager *manager = [J_AFNetWorkManager managerWithBaseURL:nil sessionConfiguration:NO];
    manager.requestSerializer=[AFJSONRequestSerializer serializer];
    NSLog(@"%@", requestUrl);
    [manager POST:requestUrl parameters:params progress:nil success:^(NSURLSessionDataTask * _Nonnull task, id  _Nullable responseObject) {
        
        id dic = [J_AFNetWorkManager responseConfiguration:responseObject];
        
        success(task,dic);
    } failure:^(NSURLSessionDataTask * _Nullable task, NSError * _Nonnull error) {
        fail(task,error);
    }];
}

+(void)POST:(NSString *)requestUrl params:(NSDictionary *)params
    success:(J_ResponseSuccess)success fail:(J_ResponseFail)fail{
    
    AFHTTPSessionManager *manager = [J_AFNetWorkManager managerWithBaseURL:nil sessionConfiguration:NO];
    NSLog(@"%@", requestUrl);
    [manager POST:requestUrl parameters:params progress:nil success:^(NSURLSessionDataTask * _Nonnull task, id  _Nullable responseObject) {
        
        id dic = [J_AFNetWorkManager responseConfiguration:responseObject];
        
        success(task,dic);
    } failure:^(NSURLSessionDataTask * _Nullable task, NSError * _Nonnull error) {
        fail(task,error);
    }];
}

+(void)POST:(NSString *)requestUrl baseURL:(NSString *)baseUrl params:(NSDictionary *)params
    success:(J_ResponseSuccess)success fail:(J_ResponseFail)fail{
    
    AFHTTPSessionManager *manager = [J_AFNetWorkManager managerWithBaseURL:baseUrl sessionConfiguration:NO];
    [manager POST:requestUrl parameters:params progress:^(NSProgress * _Nonnull uploadProgress) {
        
    } success:^(NSURLSessionDataTask * _Nonnull task, id  _Nullable responseObject) {
        
        id dic = [J_AFNetWorkManager responseConfiguration:responseObject];
        
        success(task,dic);
    } failure:^(NSURLSessionDataTask * _Nullable task, NSError * _Nonnull error) {
        fail(task,error);
    }];
}

+(void)uploadWithURL:(NSString *)requestUrl params:(NSDictionary *)params fileData:(NSData *)filedata name:(NSString *)name fileName:(NSString *)filename mimeType:(NSString *) mimeType progress:(J_Progress)progress success:(J_ResponseSuccess)success fail:(J_ResponseFail)fail{
    
    AFHTTPSessionManager *manager = [J_AFNetWorkManager managerWithBaseURL:nil sessionConfiguration:NO];
    
    [manager POST:requestUrl parameters:params constructingBodyWithBlock:^(id<AFMultipartFormData>  _Nonnull formData) {
        
        [formData appendPartWithFileData:filedata name:name fileName:filename mimeType:mimeType];
        
    } progress:^(NSProgress * _Nonnull uploadProgress) {
        
        progress(uploadProgress);
        
    } success:^(NSURLSessionDataTask * _Nonnull task, id  _Nullable responseObject) {
        
        id dic = [J_AFNetWorkManager responseConfiguration:responseObject];
        success(task,dic);
        
    } failure:^(NSURLSessionDataTask * _Nullable task, NSError * _Nonnull error) {
        fail(task,error);
    }];
}

+(void)uploadWithURL:(NSString *)requestUrl
             baseURL:(NSString *)baseurl
              params:(NSDictionary *)params
            fileData:(NSData *)filedata
                name:(NSString *)name
            fileName:(NSString *)filename
            mimeType:(NSString *) mimeType
            progress:(J_Progress)progress
             success:(J_ResponseSuccess)success
                fail:(J_ResponseFail)fail{
    
    AFHTTPSessionManager *manager = [J_AFNetWorkManager managerWithBaseURL:baseurl sessionConfiguration:YES];
    [manager POST:requestUrl parameters:params constructingBodyWithBlock:^(id<AFMultipartFormData>  _Nonnull formData) {
        [formData appendPartWithFileData:filedata name:name fileName:filename mimeType:mimeType];
    } progress:^(NSProgress * _Nonnull uploadProgress) {
        progress(uploadProgress);
    } success:^(NSURLSessionDataTask * _Nonnull task, id  _Nullable responseObject) {
        
        id dic = [J_AFNetWorkManager responseConfiguration:responseObject];
        
        success(task,dic);
        
        
        success(task,responseObject);
    } failure:^(NSURLSessionDataTask * _Nullable task, NSError * _Nonnull error) {
        fail(task,error);
    }];
}

+(NSURLSessionDownloadTask *)downloadWithURL:(NSString *)url
                                 savePathURL:(NSURL *)fileURL
                                    progress:(J_Progress )progress
                                     success:(void (^)(NSURLResponse *, NSURL *))success
                                        fail:(void (^)(NSError *))fail{
    AFHTTPSessionManager *manager = [self managerWithBaseURL:nil sessionConfiguration:YES];
    
    NSURL *urlpath = [NSURL URLWithString:url];
    NSURLRequest *request = [NSURLRequest requestWithURL:urlpath];
    
    NSURLSessionDownloadTask *downloadtask = [manager downloadTaskWithRequest:request progress:^(NSProgress * _Nonnull downloadProgress) {
        progress(downloadProgress);
        
    } destination:^NSURL * _Nonnull(NSURL * _Nonnull targetPath, NSURLResponse * _Nonnull response) {
        return  fileURL;
    } completionHandler:^(NSURLResponse * _Nonnull response, NSURL * _Nullable filePath, NSError * _Nullable error) {
        
        if (error) {
            fail(error);
        }else{
            
            success(response,filePath);
        }
    }];
    
    [downloadtask resume];
    
    return downloadtask;
}

#pragma mark - Private

+(AFHTTPSessionManager *)managerWithBaseURL:(NSString *)baseURL  sessionConfiguration:(BOOL)isconfiguration{
    
    NSURLSessionConfiguration *configuration = [NSURLSessionConfiguration defaultSessionConfiguration];
    AFHTTPSessionManager *manager =nil;
    
    NSURL *url = [NSURL URLWithString:baseURL];
    
    if (isconfiguration) {
        
        manager = [[AFHTTPSessionManager alloc] initWithBaseURL:url sessionConfiguration:configuration];
    }else{
        manager = [[AFHTTPSessionManager alloc] initWithBaseURL:url];
    }
    
    manager.requestSerializer = [AFJSONRequestSerializer serializer];
    manager.responseSerializer = [AFHTTPResponseSerializer serializer];
    
    return manager;
}

+(id)responseConfiguration:(id)responseObject{
    
    NSString *string = [[NSString alloc] initWithData:responseObject encoding:NSUTF8StringEncoding];
    if (string) {
        string = [string stringByReplacingOccurrencesOfString:@"\n" withString:@""];
        NSData *data = [string dataUsingEncoding:NSUTF8StringEncoding];
        NSDictionary *dic = [NSJSONSerialization JSONObjectWithData:data options:NSJSONReadingMutableLeaves error:nil];
        return dic;
    }else{
        return nil;
    }
    
}
@end
