//
//  SNToolManager.m
//  Luba
//
//  Created by 张浩 on 2017/4/13.
//  Copyright © 2017年 sjl. All rights reserved.
//

#import "SNToolManager.h"
#import "MBManager.h"
#import <CommonCrypto/CommonDigest.h>//MD5加密用到

@implementation SNToolManager
//生成缩略图
+ (UIImage *)getThumbnailFromImage:(UIImage*)image {
    UIImage *thumbnail;
    
    CGSize originImageSize = image.size;
    
    CGRect newRect =CGRectMake(0,0,40,40);
    
    //根据当前屏幕scaling factor创建一个透明的位图图形上下文(此处不能直接从UIGraphicsGetCurrentContext获取,原因是UIGraphicsGetCurrentContext获取的是上下文栈的顶,在drawRect:方法里栈顶才有数据,其他地方只能获取一个nil.详情看文档)
    
    UIGraphicsBeginImageContextWithOptions(newRect.size,NO,0.0);
    
    //保持宽高比例,确定缩放倍数
    
    //(原图的宽高做分母,导致大的结果比例更小,做MAX后,ratio*原图长宽得到的值最小是40,最大则比40大,这样的好处是可以让原图在画进40*40的缩略矩形画布时,origin可以取=(缩略矩形长宽减原图长宽*ratio)/2 ,这样可以得到一个可能包含负数的origin,结合缩放的原图长宽size之后,最终原图缩小后的缩略图中央刚好可以对准缩略矩形画布中央)
    
    float ratio =MAX(newRect.size.width/ originImageSize.width, newRect.size.height/ originImageSize.height);
    
    //    //创建一个圆角的矩形UIBezierPath对象
    //
    //    UIBezierPath*path = [UIBezierPath bezierPathWithRoundedRect:newRect cornerRadius:5.0];
    //
    //    //用Bezier对象裁剪上下文
    //
    //    [path addClip];
    
    //让image在缩略图范围内居中()
    
    CGRect projectRect;
    
    projectRect.size.width= originImageSize.width* ratio;
    
    projectRect.size.height= originImageSize.height* ratio;
    
    projectRect.origin.x= (newRect.size.width- projectRect.size.width) /2;
    
    projectRect.origin.y= (newRect.size.height- projectRect.size.height) /2;
    
    //在上下文中画图
    
    [image drawInRect:projectRect];
    
    //从图形上下文获取到UIImage对象,赋值给thumbnai属性
    
    UIImage*smallImg =UIGraphicsGetImageFromCurrentImageContext();
    
    thumbnail= smallImg;
    
    //清理图形上下文(用了UIGraphicsBeginImageContext需要清理)
    
    UIGraphicsEndImageContext();
    return thumbnail;
}

//车牌号正则
+ (BOOL)validateCarNo:(NSString*)carNo
{
    NSString *carRegex = @"^[\u4e00-\u9fa5]{1}[A-Za-z]{1}[A-Za-z_0-9]{5}$";
    NSPredicate *carTest = [NSPredicate predicateWithFormat:@"SELF MATCHES %@",carRegex];
    NSLog(@"carTest is %@",carTest);
    return [carTest evaluateWithObject:carNo];
}

//时间显示
+ (NSString*)showTime:(NSTimeInterval)msgSendTime{
//    NSLog(@"%f",msgSendTime);
    //转为NSdate
    NSDate *timeDate = [NSDate dateWithTimeIntervalSince1970:msgSendTime];
    //得到与当前时间差
    NSTimeInterval timeInterval = [timeDate timeIntervalSinceNow];
    timeInterval = -timeInterval;
    long temp = 0;
    NSString *result;

    if (timeInterval <= 60) {
        result = [NSString stringWithFormat:@"刚刚"];
    }else if((temp = timeInterval/60) < 60){
        result = [NSString stringWithFormat:@"%ld分钟前",temp];
    }else if((temp = timeInterval/3600) >= 1 && (temp = timeInterval/3600) <24){
        result = [NSString stringWithFormat:@"%ld小时前",temp];
    }else if ((temp = timeInterval/3600) >= 24 && (temp = timeInterval/3600) < 48){
        result = [NSString stringWithFormat:@"昨天"];
    }else if ((temp = timeInterval/3600) >= 48 && (temp = timeInterval/3600) < 72){
        result = [NSString stringWithFormat:@"前天"];
    }else{
        temp = timeInterval/3600/24;
        result = [NSString stringWithFormat:@"%ld天前",temp];
    }
    return result;
}

+(NSString*)calculateOldTime:(NSString*)oldTimeString{
    NSString* timeStr;
    NSDateFormatter*dateFormatter=[[NSDateFormatter alloc]init];
    [dateFormatter setDateFormat:@"yyyy-MM-dd HH:mm:ss"];
    
    long long currentTime=[NSDate date].timeIntervalSince1970;
    long long oldTime=[dateFormatter dateFromString:oldTimeString].timeIntervalSince1970;
    
    BOOL isMin=NO;
    BOOL isHour = NO;
    BOOL isDay = NO;
    
    long long time=(currentTime-oldTime);
    if (time>=60) {
        if (time>86400) {
            time=time/86400;
            isDay=YES;
        }
        else if (time>3600){
            time=time/3600;
            isHour=YES;
        }
        else{
            time=time/60;
            isMin=YES;
        }
    }else{
        isMin=NO;
    }
    if (isDay) {
        timeStr=[NSString stringWithFormat:@"%lld天前",time];
    }else if (isHour){
        timeStr=[NSString stringWithFormat:@"%lld小时前",time];
    }else if (isMin){
        timeStr=[NSString stringWithFormat:@"%lld分钟前",time];
    } else {
        if(time>0){
            timeStr=[NSString stringWithFormat:@"%lld秒前",time];
        }else{
            timeStr = @"刚刚";
        }
    }
    return timeStr;
}

//时间显示  月-日 时:分
+ (NSString *)showMonthDayTime:(NSTimeInterval)msgSendTime{
    NSString *result;
    NSDate *timeDate = [NSDate dateWithTimeIntervalSince1970:msgSendTime];
    NSDateFormatter *formatter = [[NSDateFormatter alloc] init];
    [formatter setDateFormat:@"MM-dd HH:mm"];
    result = [formatter stringFromDate: timeDate];
//    NSLog(@"服务器返回的时间戳对应的时间是:%@",result);
    return result;
}
 

 
/**
 *  付款金额限制代码
 *
 *  @param textField    当前textField
 *  @param range        range
 *  @param string       string
 *  @param dotPreBits   小数点前整数位数
 *  @param dotAfterBits 小数点后位数
 *
 *  @return shouldChangeCharactersInRange 代理方法中 可以限制金额格式
 */

+ (BOOL) limitPayMoneyDot:(UITextField *)textField shouldChangeCharactersInRange:(NSRange)range replacementString:(NSString *)string dotPreBits:(int)dotPreBits dotAfterBits:(int)dotAfterBits

{
    if ([string isEqualToString:@"\n"]||[string isEqualToString:@""])
    { //按下return
        return YES;
    }
    
    NSCharacterSet *cs;
    NSUInteger nDotLoc = [textField.text rangeOfString:@"."].location;
    if (NSNotFound == nDotLoc && 0 != range.location)
    {
        cs = [[NSCharacterSet characterSetWithCharactersInString:string]invertedSet];
        if ([string isEqualToString:@"."])
        {
            return YES;
        }
        if (textField.text.length >= dotPreBits)
        {  //小数点前面6位
            // [textField resignFirstResponder];
            [MBManager showBriefAlert:[NSString stringWithFormat:@"只允许小数前%d位", dotPreBits]];
            return NO;
        }
    }
    else
    {
        cs = [[NSCharacterSet characterSetWithCharactersInString:string]invertedSet];
        if (textField.text.length >= dotPreBits + dotAfterBits + 1)
        {
            [textField resignFirstResponder];
            [MBManager showBriefAlert:[NSString stringWithFormat:@"只允许小数点后%d位", dotAfterBits]];
            return  NO;
        }
    }
    NSString *filtered = [[string componentsSeparatedByCharactersInSet:cs] componentsJoinedByString:@""];
    BOOL basicTest = [string isEqualToString:filtered];
    if (!basicTest)
    {
        [textField resignFirstResponder];
        [MBManager showBriefAlert:[NSString stringWithFormat:@"只允许小数点后%d位", dotAfterBits]];
        return NO;
    }
    if (NSNotFound != nDotLoc && range.location > nDotLoc +2)
    {  //小数点后面两位
        [textField resignFirstResponder];
        [MBManager showBriefAlert:[NSString stringWithFormat:@"只允许小数点后%d位", dotAfterBits]];
        return NO;
    }
    return YES;
}

//根据高德定位返回的course，确定当前方向
+(NSString *)calculateTheAngleStr:(CLLocationDirection)direction
{
    NSString *angleStr;
    switch ((int)direction / 90) {
        case 0:
            angleStr = @"北偏东";
            break;
        case 1:
            angleStr = @"东偏南";
            break;
        case 2:
            angleStr = @"南偏西";
            break;
        case 3:
            angleStr = @"西偏北";
            break;
        default:
            angleStr = @"掉沟里去了";
            break;
    }
    return angleStr;
}
/**  中文转拼音  */
+ (NSString *)pinYinWithString:(NSString *)chinese
{
    NSString  * pinYinStr = [NSString string];
    if (chinese.length){
        NSMutableString *pinYin = [[NSMutableString alloc]initWithString:chinese];
        //1.先转换为带声调的拼音
        if(CFStringTransform((__bridge CFMutableStringRef)pinYin, 0, kCFStringTransformMandarinLatin, NO)) {
            NSLog(@"pinyin: %@", pinYin);
        }
        //2.再转换为不带声调的拼音
        if (CFStringTransform((__bridge CFMutableStringRef)pinYin, 0, kCFStringTransformStripDiacritics, NO)) {
            NSLog(@"pinyin: %@", pinYin);
            //3.去除掉首尾的空白字符和换行字符
            pinYinStr = [pinYin stringByTrimmingCharactersInSet:[NSCharacterSet whitespaceAndNewlineCharacterSet]];
            //4.去除掉其它位置的空白字符和换行字符
            pinYinStr = [pinYinStr stringByReplacingOccurrencesOfString:@"\r" withString:@""];
            pinYinStr = [pinYinStr stringByReplacingOccurrencesOfString:@"\n" withString:@""];
            pinYinStr = [pinYinStr stringByReplacingOccurrencesOfString:@" " withString:@""];
        }
    }
    NSLog(@"pinyin: %@", pinYinStr);
    return pinYinStr;
}
//Json转字典
+ (NSDictionary *)dictionaryWithJsonString:(NSString *)jsonString {
    if (jsonString == nil) {
        return nil;
    }
    NSData *jsonData = [jsonString dataUsingEncoding:NSUTF8StringEncoding];
    NSError *err;
    NSDictionary *dic = [NSJSONSerialization JSONObjectWithData:jsonData
                                                        options:NSJSONReadingMutableContainers                                                          error:&err];
    if(err) {
        NSLog(@"json解析失败：%@",err);
        return nil;
    }
    return dic;
}
//Json转数组
+ (NSArray *)arrayWithJsonString:(NSString *)jsonString {
    if (jsonString == nil) {
        return nil;
    }
    NSData *jsonData = [jsonString dataUsingEncoding:NSUTF8StringEncoding];
    NSError *err;
    NSArray *arr = [NSJSONSerialization JSONObjectWithData:jsonData
                                                   options:NSJSONReadingMutableContainers
                                                     error:&err];
    if(err) {
        NSLog(@"json解析失败：%@",err);
        return nil;
    }
    return arr;
}
//获取当前时间戳
+ (NSString *)getCurrentTimeStamp {
    
    NSDateFormatter *formatter = [[NSDateFormatter alloc] init];
    [formatter setDateStyle:NSDateFormatterMediumStyle];
    [formatter setTimeStyle:NSDateFormatterShortStyle];
    [formatter setDateFormat:@"YYYY-MM-dd HH:mm:ss"]; // ----------设置你想要的格式,hh与HH的区别:分别表示12小时制,24小时制
    
    //设置时区,这个对于时间的处理有时很重要
    NSTimeZone* timeZone = [NSTimeZone timeZoneWithName:@"Asia/Beijing"];
    [formatter setTimeZone:timeZone];
    NSDate *datenow = [NSDate date];//现在时间
    
    //时间转时间戳的方法:
    NSInteger timeSp = [[NSNumber numberWithDouble:[datenow timeIntervalSince1970]] integerValue];
    NSString *ts = [NSString stringWithFormat:@"%ld",(long)timeSp];//时间戳的值
    return ts;
}
//时间戳取差值
/**持续时间*/
+ (long long)getDurationStartTime:(NSString *)startTime endTime:(NSString *)endTime {
    if (startTime && endTime) {
        long long aTime = [endTime longLongValue] - [startTime longLongValue];
        return aTime;
    } else {
        return -1;
    }
}

+ (NSString *)calculateConstellationWithMonth:(NSInteger)month day:(NSInteger)day
{
    NSString *astroString = @"魔羯水瓶双鱼白羊金牛双子巨蟹狮子处女天秤天蝎射手魔羯";
    NSString *astroFormat = @"102123444543";
    NSString *result;
    
    if (month<1 || month>12 || day<1 || day>31){
        return  @"未知";
    }
    
    if(month==2 && day>29)
    {
        return  @"未知";
    }else if(month==4 || month==6 || month==9 || month==11) {
        if (day>30) {
            return  @"未知";
        }
    }
    
    result=[NSString stringWithFormat:@"%@",[astroString substringWithRange:NSMakeRange(month*2-(day < [[astroFormat substringWithRange:NSMakeRange((month-1), 1)] intValue] - (-19))*2,2)]];
    
    return [NSString stringWithFormat:@"%@座",result];
}

+(UIColor*)getColor:(NSString*)startString{
    NSString* colorString = [NSString string];
    if ([startString isEqualToString:@"水瓶座"]) {
        colorString = @"#821F5F";
    }else if ([startString isEqualToString:@"金牛座"]) {
        colorString = @"#D5470D";
    }else if ([startString isEqualToString:@"狮子座"]) {
        colorString = @"#FFCB00";
    }else if ([startString isEqualToString:@"天蝎座"]) {
        colorString = @"#189F79";
    }else if ([startString isEqualToString:@"射手座"]) {
        colorString = @"#334298";
    }else if ([startString isEqualToString:@"处女座"]) {
        colorString = @"#A4C836";
    }else if ([startString isEqualToString:@"魔羯座"]) {
        colorString = @"#7041B2";
    }else if ([startString isEqualToString:@"白羊座"]) {
        colorString = @"#E61520";
    }else if ([startString isEqualToString:@"巨蟹座"]) {
        colorString = @"#DB9E38";
    }else if ([startString isEqualToString:@"天秤座"]) {
        colorString = @"#058727";
    }else if ([startString isEqualToString:@"双鱼座"]) {
        colorString = @"#D168B3";
    }else if ([startString isEqualToString:@"双子座"]) {
        colorString = @"#FD7A02";
    }else{
        return [UIColor clearColor];
    }
    return [self colorWithHexString:colorString alpha:1.0f];
}
+ (UIColor *)colorWithHexString:(NSString *)color alpha:(CGFloat)alpha
{
    //删除字符串中的空格
    NSString *cString = [[color stringByTrimmingCharactersInSet:[NSCharacterSet whitespaceAndNewlineCharacterSet]] uppercaseString];
    // String should be 6 or 8 characters
    if ([cString length] < 6)
    {
        return [UIColor clearColor];
    }
    // strip 0X if it appears
    //如果是0x开头的，那么截取字符串，字符串从索引为2的位置开始，一直到末尾
    if ([cString hasPrefix:@"0X"])
    {
        cString = [cString substringFromIndex:2];
    }
    //如果是#开头的，那么截取字符串，字符串从索引为1的位置开始，一直到末尾
    if ([cString hasPrefix:@"#"])
    {
        cString = [cString substringFromIndex:1];
    }
    if ([cString length] != 6)
    {
        return [UIColor clearColor];
    }
    
    // Separate into r, g, b substrings
    NSRange range;
    range.location = 0;
    range.length = 2;
    //r
    NSString *rString = [cString substringWithRange:range];
    //g
    range.location = 2;
    NSString *gString = [cString substringWithRange:range];
    //b
    range.location = 4;
    NSString *bString = [cString substringWithRange:range];
    
    // Scan values
    unsigned int r, g, b;
    [[NSScanner scannerWithString:rString] scanHexInt:&r];
    [[NSScanner scannerWithString:gString] scanHexInt:&g];
    [[NSScanner scannerWithString:bString] scanHexInt:&b];
    return [UIColor colorWithRed:((float)r / 255.0f) green:((float)g / 255.0f) blue:((float)b / 255.0f) alpha:alpha];
}
+(NSString *)md5:(NSString *)str {
    const char *cStr = [str UTF8String];//转换成utf-8
    unsigned char result[16];//开辟一个16字节（128位：md5加密出来就是128位/bit）的空间（一个字节=8字位=8个二进制数）
    CC_MD5(cStr, (CC_LONG)strlen(cStr), result);
    /*
     添加属性(CC_LONG)
     extern unsigned char *CC_MD5(const void *data, CC_LONG len, unsigned char *md)官方封装好的加密方法
     把cStr字符串转换成了32位的16进制数列（这个过程不可逆转） 存储到了result这个空间中
     */
    return [NSString stringWithFormat:
            @"%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x%02x",
            result[0], result[1], result[2], result[3],
            result[4], result[5], result[6], result[7],
            result[8], result[9], result[10], result[11],
            result[12], result[13], result[14], result[15]
            ];
    /*
     x表示十六进制，%02X  意思是不足两位将用0补齐，如果多余两位则不影响
     NSLog("%02X", 0x888);  //888
     NSLog("%02X", 0x4); //04
     */
}
@end
